/* This program will generate a Cyclades Cyclom-Z byte-file required by the
   driver from a zlogic.cyz file supplied by Cyclades. This program can be
   used to upgrade the firmware used by the driver. For more info, see the
   RELNOTES file. */

#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>

long unsigned int bz_load_ecoff(FILE *file, char *ramP);

void main(int argc, char *argv[])
  {
    FILE *inputfile, *outputfile;
    unsigned char *data;
    unsigned long int max_size, size_to_use,i;
    unsigned short int wrap_value;

    if (argc < 4)
      {
        fprintf(stderr,"Usage: fwbuild <firmware> <.h file> <variable name>\n");
	exit(1);
      }
    inputfile = fopen(argv[1],"r");
    if (inputfile == NULL)
      {
        fprintf(stderr,"Couldn't open input file %s.\n", argv[1]);
	exit(1);
      }
    outputfile = fopen(argv[2],"w");
    if (outputfile == NULL)
      {
        fprintf(stderr,"Couldn't open output file %s.\n", argv[2]);
	exit(1);
      }
    fseek(inputfile, 0L, SEEK_END);
    max_size = ftell(inputfile);
    fseek(inputfile, 0L, SEEK_SET);
    data = (unsigned char *)malloc(max_size);
    fread(data, max_size, 1, inputfile);
    fprintf(outputfile, "#ifndef %s_INCLUDED\n\n",argv[3]);
    fprintf(outputfile, "static unsigned char %s[] = {\n",argv[3]);
    wrap_value = 0;
    for (i=0; i < max_size;i++)
      {
        fprintf(outputfile,"%d, ",data[i]);
	wrap_value++;
	if (wrap_value > 10)
	  {
	    fprintf(outputfile,"\n");
	    wrap_value = 0;
	  }
      }
    fprintf(outputfile,"0};\n\n");
    fprintf(outputfile,"#define %s_SIZE %d\n", argv[3],max_size);
    fprintf(outputfile,"\n\n#endif /* %s_INCLUDED */\n",argv[3]);
    fclose(inputfile);
    fclose(outputfile);
  }
